/* Version vom 30.08. 2009.

BESCHREIBUNG:

Funktion des Script's:

1. Laden des Netzes.
2. Laden der Lessons/Daten.
3. Einstellen der Views/Charts.
4. Einstellen des Teachers/Lehrers.
5. Das Netz normalisieren.
6. Das Netz bis zum Abbruchkriterium (Zeit, Lessons, NetError) trainieren.
5. Das trainierte Netz abspeichern.
6. Abarbeiten einer "Think-Lesson".
   (Mit jeder Zeile der "Think-Lesson" DENKT das Netz einmal, und erzeugt dabei den Output).
7. Abspeichern des Outputs in einer CSV-Datei (Output.csv).


Voraussetzung:

1. Ein Netz, das zu Deinen Daten/Lessons pat (Anzahl der IN/OUT Put-Neuronen).

2. Vier(4) Dateien/Lessons. 

   a. Die "Normalize Lesson".
      (In dieser Datei sollten ALLE Werte enthalten sein, die die IN/OUT Put-Neuronen jemals erreichen knnen).
      (Es geht hier um die minimal und maximal Werte der IN/OUT Put-Neuronen).
      (Wenn Ihr euch nicht sicher seid, benutzt einfach die "Trainings / Learn - Lesson" zum normalisieren).
      (Diese kann ber die Einstellung "AUTO_CREATE_NORMALIZE_LESSON" auch automatisch aus den drei anderen Lessons erzeugt werden).

   b. Die "Learn Lesson".
      (In dieser Datei befinden sich die Daten, mit denen das Netz trainiert wird).

   c. Die "Validate Lesson".
      (In dieser Datei befinden sich die Daten, die von den Trainingsdaten abgezweigt wurden (ca. 5 - 10 % der Trainingsdaten).
      (Um das Netz mit "NICHT trainierten Daten" zu prfen/testen).

   d. Die "Think Lesson".
      (In dieser Datei befinden sich die Daten, mit denen man eine Prognose erstellen will).
      (Diese Datei enthlt NUR die Inputs, die Outputs werden ja durch das Netz erzeugt).

3. Es sollte ein "Net Error" Wert bekannt sein, der mit dem Netz und den Learn/Validate Daten auch erreicht werden kann.
   (Das knnt Ihr z.B. mit dem Script "Traintime" herausfinden).


Bedienung:

1. Ladet den Editor "PSPad" herunter und installiert diesen.
   http://www.pspad.com
   (Dieser Editor ist Freeware, kostet NICHTS, hat "Syntax Highlighting" und kann sehr gut fr MemBrain/AngelScript eingerichtet werden).
   (Es geht natrlich auch mit "Windows Editor", dann aber OHNE Farbe).

2. Entpackt die ZIP-Datei "Base.zip" in einen Ordner.

3. Kopiert alle Dateien aus diesem Ordner, in den Ordner, der auch das Netz und die Daten/Lessons enthlt.
   ("NetEditor.as, Position.as und SecondsTimer.as" MSSEN ZWINGEND im selben Ordner sein).

4. ffnet das Script "Base.as" mit "PSPad / Win Editor".
   (Ist eine reine Text-Datei, also bitte nicht mit MS-Word im DOC-Format abspeichern).

5. ndern / berprfen ALLER "Einstellungen" oben im Script, NACH der Beschreibung und INNERHALB der gestrichelten Zeilen, zwischen:

   // BEGINN der Einstellungen, bitte anpassen !!!
   UND
   // ENDE der Einstellungen, danke...

   Ihr mt immer den Wert RECHTS vom "=" ndern.
   Wenn Ihr mit einem Wert NICHTS anfangen knnt, dann last in erstmal UNVERNDERT !!!

   5.1  Wie oft soll das Script abgearbeitet werden (Init_Always - Think_Lesson in main() ) ?

   5.2  Dateiname des Netzes.

   5.3  Das Dateiformat der Lessons.
        "1" = RAW CSV (Standart Excel CSV-Format).
        "2" = MemBrain CSV (MemBrain Sectioned CSV-Format).
        "3" = MemBrain MBL (MemBrain Standart Lessons MBL-Format).
   5.4  Soll die Normalize - Lesson automatisch aus den anderen drei Lessons erzeugt werden ?
   5.5  Dateinamen aller Lessons/Dateien.

   5.6  Soll der "Net Error Viewer" angezeigt werden ?
   5.7  Soll der "Pattern Error Viewer" angezeigt werden ?
   5.8  Nach wieviel Sekunden soll der "Pattern Error Viewer" Chart in der Hhe angepasst werden (Y-Fit) ?

   5.9  Name des Teachers
        (Dieser mu natrlich auch bei den Teachers vorhanden/eingetragen sein).
   5.10 Die Lernrate des Teachers.
   5.11 Die Reihenfolge in der die Lern / Trainingsdaten gelernt werden.

   5.12 Soll das Training nach einer bestimmten Zeit abgebrochen werden ?
   5.13 Soll bei Trainingsabbruch durch "Zeit" ein "Think ausgefhrt / Output gespeichert" werden ?
   5.14 Nach welcher Zeit (In Sekunden) soll das Training abgebrochen werden ?
   
   5.15 Soll das Training nach einer bestimmten Anzahl Durchlufe der Lern / Trainings - Lesson (Lesson Repetitions) abgebrochen werden ?
   5.16 Soll bei Trainingsabbruch durch "Lesson Repetitions" ein "Think ausgefhrt / Output gespeichert" werden ?
   5.17 Nach wievielen Durchlufen der Lern / Trainings - Lesson (Lesson Repetitions) soll das Training abgebrochen werden ?

   5.18 Soll das Training bei erreichen eines bestimmten Net Errors abgebrochen werden ?
   5.19 Soll bei Trainingsabbruch durch "Net Error" ein "Think ausgefhrt / Output gespeichert" werden ?
   5.20 Bei welchem "Net Error" (z.B. 0.002) soll das Training abgebrochen werden ?

   5.21 Sollen in der Output - Lesson - Datei auch die Input-Daten des Netzes enthalten sein ?
   5.22 Soll die "Output" CSV-Datei am Ende des Scripts z.B. mit Excel geffnet werden ?

   5.23 Soll "MemBrain" am Ende des Scripts auch beendet werden ?
   
6. Startet "MemBrain".

7. Startet das Script im Men ber "Scripting > Execute Script...".

*/

// BEGINN der Einstellungen, bitte anpassen !!!
// -----------------------------------------------------------------------------

// Wie oft soll das Script ablaufen ?
// Damit ist der Bereich in der Funktion main() gemeint, der in der "while" Schleife steht.
// Es wird also so oft das gleiche Netz "Net.mbn" resettet, trainiert, abgespeichert und die "Tink" Lesson durchlaufen / Outputs erzeugt.
const uint32 MAX_SCRIPT_COUNT = 1;

// Dateiname des Netzes.
const string NET_FILE_NAME = "Net.mbn";

// Dateiformat der Lessons.
// "1" = RAW CSV (Standart Excel CSV-Format).
// "2" = MemBrain CSV (MemBrain Sectioned CSV-Format).
// "3" = MemBrain MBL (MemBrain Standart Lessons MBL-Format).
const uint8 LESSON_FILE_TYPE = 1;
// Soll die Normalize - Lesson automatisch aus den anderen drei Lessons erzeugt werden ?
const bool AUTO_CREATE_NORMALIZE_LESSON = true;
// Dateiname der Normalize - Lesson - Datei.
// Wenn "AUTO_CREATE_NORMALIZE_LESSON" = true, dann wird diese Einstellung ignoriert,
// da die Normalize - Lesson aus den anderen drei Lessons erzeugt.
const string NORMALIZE_LESSON_FILE_NAME = "Normalize.csv";
// Dateiname der Learn - Lesson - Datei.
const string LEARN_LESSON_FILE_NAME = "Learn.csv";
// Dateiname der Validate - Lesson - Datei.
const string VALIDATE_LESSON_FILE_NAME = "Validate.csv";
// Dateiname der Think - Lesson - Datei.
const string THINK_LESSON_FILE_NAME = "Think.csv";
// Dateiname der Output - Lesson - Datei.
const string OUTPUT_LESSON_FILE_NAME = "Output.csv";

// Soll der "Net Error Viewer" angezeigt werden (true = Ja, false = Nein) ?
const bool SHOW_NET_ERROR_VIEWER = true;
// Soll der "Pattern Error Viewer" angezeigt werden (true = Ja, false = Nein) ?
const bool SHOW_PATTERN_ERROR_VIEWER = true;
// Nach wieviel Sekunden soll der "Pattern Error Viewer" Chart in der Hhe angepasst werden (Y-Fit) ?
const uint8 Y_FIT_PATTERN_ERROR_VIEWER = 1;

// Der Name des Teachers/Lehrers.
const string TEACHER_NAME = "RPROP";
// Die Lernrate des Teachers/Lehrers.
const double TEACHER_LEARN_RATE = 0.05;
// Die Reihenfolge in der die Trainingsdaten gelernt werden.
// "ORDERED" = Alle Zeilen werden von oben nach unten abgearbeitet.
// "RAND_ORDER" = Jede Zeile wird bei einem Durchlauf min. 1 x verwendet, aber in zuflliger abfolge.
// "RAND_SELECT" = Rein zufllige abfolge, evtl. wird der eine oder andere Wert auch nie verwertet.
EPatternSelect TEACHER_PATTERN_ORDER = ORDERED;

// Soll das Training nach einer bestimmten Zeit abgebrochen werden, (true = Ja, false = Nein) ?
const bool EXIT_LEARNING_BY_TIME = true;
// Soll bei Trainingsabbruch durch "Zeit" ein "Think ausgefhrt / Output gespeichert" werden, (true = Ja, false = Nein) ?
const bool THINK_OUTPUT_BY_TIME = false;
// Nach welcher Zeit (In Sekunden) soll das Training abgebrochen werden.
const uint32 EXIT_LEARNING_MAX_SECONDS = 120;

// Soll das Training nach einer bestimmten Anzahl Durchlufe der Learn / Trainings - Lesson (Lesson Repetitions) abgebrochen werden, (true = Ja, false = Nein) ?
const bool EXIT_LEARNING_BY_LESSON_REPETITIONS = true;
// Soll bei Trainingsabbruch durch "Lesson Repetitions" ein "Think ausgefhrt / Output gespeichert" werden, (true = Ja, false = Nein) ?
const bool THINK_OUTPUT_BY_LESSON_REPETITIONS = false;
// Nach wievielen Durchlufen der Learn / Trainings - Lesson (Lesson Repetitions) soll das Training abgebrochen werden.
const uint32 EXIT_LEARNING_MAX_LESSON_REPETITIONS = 2000;

// Soll das Training bei erreichen eines bestimmten Net Errors abgebrochen werden, (true = Ja, false = Nein) ?
const bool EXIT_LEARNING_BY_NET_ERROR = true;
// Soll bei Trainingsabbruch durch "Net Error" ein "Think ausgefhrt / Output gespeichert" werden, (true = Ja, false = Nein) ?
const bool THINK_OUTPUT_BY_NET_ERROR = true;
// Bei welchem "Net Error" (z.B. 0.002) soll das Training abgebrochen werden.
const double EXIT_LEARNING_NET_ERROR = 0.1;

// Sollen in der Output - Lesson - Datei auch die Input-Daten des Netzes enthalten sein ?
const bool INCLUDE_INPUT_DATA_IN_OUTPUT_LESSON = true;
// Soll die "Output" CSV-Datei am Ende des Scripts z.B. mit Excel geffnet werden, (true = Ja, false = Nein) ?
const bool OPEN_OUTPUT_FILE_ON_EXIT = true;

// Soll "MemBrain" am Ende des Scripts auch beendet werden, (true = Ja, false = Nein) ?
const bool CLOSE_MEMBRAIN_ON_EXIT = false;

// Enumeration der Lessons.
enum ELessonNumber
{
    LESSON_COUNT = 5,     // Anzahl der Lessons insgesamt.
    NORMALIZE_LESSON = 1, // Die "Normalize" Lesson ist Nr. 1 im Lesson Editor.
    LEARN_LESSON = 2,     // Die "Learn" Lesson ist     Nr. 2 im Lesson Editor.
    VALIDATE_LESSON = 3,  // Die "Validate" Lesson ist  Nr. 3 im Lesson Editor.
    THINK_LESSON = 4,     // Die "Think" Lesson ist     Nr. 4 im Lesson Editor.
    OUTPUT_LESSON = 5     // Die "Output" Lesson ist    Nr. 5 im Lesson Editor.
};

// Welche Lesson soll fr "Normalize" verwendet werden.
const uint8 LESSON_FOR_NORMALIZE = NORMALIZE_LESSON;

// Welche Lesson soll fr "Learn" verwendet werden.
const uint8 LESSON_FOR_LEARN = LEARN_LESSON;

// Welche Lesson soll fr "Validate" verwendet werden.
const uint8 LESSON_FOR_VALIDATE = VALIDATE_LESSON;

// Welche Lesson soll fr "Think" verwendet werden.
const uint8 LESSON_FOR_THINK = THINK_LESSON;

// Welche Lesson soll fr "Output" verwendet werden.
const uint8 LESSON_FOR_OUTPUT = OUTPUT_LESSON;

// -----------------------------------------------------------------------------
// ENDE der Einstellungen, danke...

// Einbinden des Scripts "NetEditor.as".
#include "NetEditor.as";

// Einbinden des Scripts "SecondsTimer.as".
#include "SecondsTimer.as";

// Das NetEditor Object.
NetEditor Editor;

// Globale Variable fr die Anzahl der Script Durchlufe.
uint32 script_Count = 0;

// Globale Variable fr den Teacher Abbruch.
uint8 teacher_Exit_Code = 0;  // Wie wurde das Training abgebrochen, (1 = Zeit, 2 = Lesson Repetitions, 3 = Net Error) ?

// Array mit den Namen der Lesson-Dateien
string[] LESSON_NAMES(LESSON_COUNT); 

// Das Hauptprogramm.
void main()
{
  Init_First();                // Aufruf der Funktion "Init_First".
  Load_Net();                  // Aufruf der Funktion "Load_Net".
  Init_Lessons();              // Aufruf der Funktion "Init_Lessons".
  Load_Lessons();              // Aufruf der Funktion "Load_Lessons".
  View_Settings();             // Aufruf der Funktion "View_Settings".
  Teacher_Settings();          // Aufruf der Funktion "Teacher_Settings".
  Clear_Output_Lesson();       // Aufruf der Funktion "Clear_Output_Lesson".
  Select_Normalize_Lesson();   // Aufruf der Funktion "Select_Normalize_Lesson".
  Normalize_Net();             // Aufruf der Funktion "Normalize_Net".

  while (script_Count < MAX_SCRIPT_COUNT) // Solange "script_Count" kleiner "MAX_SCRIPT_COUNT" diese Schleife durchlaufen.
  {
    Init_Always();             // Aufruf der Funktion "Init_Always".
    Select_Learn_Lesson();     // Aufruf der Funktion "Select_Learn_Lesson".
    Select_Net_Error_Lesson(); // Aufruf der Funktion "Select_Net_Error_Lesson".
    Reset_Net();               // Aufruf der Funktion "Reset_Net".
    Train_Net();               // Aufruf der Funktion "Train_Net".
    Save_Net();                // Aufruf der Funktion "Save_Net".
    Select_Think_Lesson();     // Aufruf der Funktion "Select_Think_Lesson".
    Think_Lesson();            // Aufruf der Funktion "Think_Lesson".
    script_Count++;            // Die Variable "script_Count" um 1 erhhen.
    Trace("Das Script wurde: " + script_Count + " mal von " + MAX_SCRIPT_COUNT + " mal durchlaufen.\n");
  }

  Select_Output_Lesson();      // Aufruf der Funktion "Select_Output_Lesson".
  Save_Output();               // Aufruf der Funktion "Save_Output".
  Open_Output_File();          // Aufruf der Funktion "Open_Output_File".
  Clear_Before_Exit();         // Aufruf der Funktion "Init_Last".
  
  if (CLOSE_MEMBRAIN_ON_EXIT)  // Ist "CLOSE_MEMBRAIN_ON_EXIT" = true, dann hier weiter.
  {
    ExitMemBrain();            // MemBrain wird beendet.
  }
}

// Verschiedene Werte zurcksetzen / initialisieren.
// Diese Funktion wird nur 1 x beim Start des Script's ausgefhrt.
void Init_First()
{
  StopThink();                  // Alle Think-Vorgnge werden gestopt.
  StopTeaching();               // Alle Teaching-Vorgnge werden gestopt.
  
  // Alle Lesson - Dateinamen in das Array "LESSON_NAMES" einlesen.
  LESSON_NAMES[NORMALIZE_LESSON - 1] = NORMALIZE_LESSON_FILE_NAME;
  LESSON_NAMES[LEARN_LESSON - 1] = LEARN_LESSON_FILE_NAME;
  LESSON_NAMES[VALIDATE_LESSON - 1] = VALIDATE_LESSON_FILE_NAME;
  LESSON_NAMES[THINK_LESSON - 1] = THINK_LESSON_FILE_NAME;
  LESSON_NAMES[OUTPUT_LESSON - 1] = OUTPUT_LESSON_FILE_NAME;
}

// ffnen der Netzdatei z.B. "Net.mbn".
void Load_Net()
{
  OpenNet(NET_FILE_NAME); // Das Netz laden.
}

// Initialisieren der Lessons.
void Init_Lessons()
{
  SetLessonCount(1);              // Alle Lessons bis auf die erste lschen.
  ClearLesson();                  // Den Inhalt der ersten Lesson auch lschen.
  // Wenn neue Lessons erzeugt werden, dann wird die aktive Lesson (1) als Vorlage gewhlt.
  // Deshalb wird die Lesson Nr. 1 jetzt so angepasst, dass sie eine gute Vorlage fr alle weiteren Lessons wird.
  NamesFromNet();                 // Anzahl und Namen der IN/OUT put Neuronen vom Netz bernehmen.
  EnableLessonOutData(true);      // Die Outputs der Lessons aktivieren.
  SetLessonCount(LESSON_COUNT);   // Anzahl der Lessons insgesamt setzen.
}

// ffnen aller Lessons, je nach Lessontype.
void Load_Lessons()
{
  for (uint8 i = 1; i <= LESSON_COUNT; i++)
  {
    if (i != OUTPUT_LESSON)
    {
      SelectLesson(i);

      if (i == NORMALIZE_LESSON)
      {
        if (AUTO_CREATE_NORMALIZE_LESSON)
        {
          CreateNormalizeLesson(); // Temporre Normalize-Lesson erzeugen, wenn kein Dateiname vorhanden ist.
        }
        else
        {
          OpenLessonFile(i);
        }
      }
      else
      {
        OpenLessonFile(i);
      }
    }
  }
}

// ffnen einer Lesson-Datei
void OpenLessonFile(uint8 lessonNumber)
{
  switch (LESSON_FILE_TYPE) // Laden der Lessons, je nach Lessontype.
  {
    case 1:                   // Wenn "LESSON_FILE_TYPE = 1" (Raw CSV), dann die Lessons hier laden.
      if (lessonNumber == THINK_LESSON)
      {
        ImportLessonInputsRaw(LESSON_NAMES[lessonNumber - 1]);   
      }
      else
      {
        ImportLessonRaw(LESSON_NAMES[lessonNumber - 1]);   
      }         
      break;
    
    case 2:                   // Wenn "LESSON_FILE_TYPE = 2" (MemBrain Sectioned CSV), dann die Lessons hier laden.
      ImportLesson(LESSON_NAMES[lessonNumber - 1]);       
      break;
    
    case 3:                   // Wenn "LESSON_FILE_TYPE = 3" (MemBrain Lesson MBL), dann die Lessons hier laden.
      LoadLesson(LESSON_NAMES[lessonNumber - 1]);        
      break;
    
    default:                  // Alle anderen Werte in "LESSON_FILE_TYPE" erzeugen diese Fehlermeldung.
      Error("Ungltiger Wert fr \"LESSON_FILE_TYPE\": " + LESSON_FILE_TYPE + " !!!\n");
  }
}

// Eine temporre Normalisierungslesson wird aus den anderen drei Lessons erzeugt.
void CreateNormalizeLesson()
{
  if (LESSON_FILE_TYPE != 3)
  {
    OpenLessonFile(LEARN_LESSON);
    SaveLesson("Learn.mbl");
    OpenLessonFile(VALIDATE_LESSON);
    SaveLesson("Validate.mbl");
    OpenLessonFile(THINK_LESSON);
    SaveLesson("Think.mbl");
    LoadLesson("Learn.mbl");
    AppendLesson("Validate.mbl");
    AppendLesson("Think.mbl");
  }
  else
  {
    LoadLesson(LESSON_NAMES[LEARN_LESSON - 1]);
    AppendLesson(LESSON_NAMES[VALIDATE_LESSON - 1]);
    AppendLesson(LESSON_NAMES[THINK_LESSON - 1]);
  }

  SaveLesson("Normalize.mbl");
}

// Einstellungen fr das Erscheinungsbild / Optik.
void View_Settings()
{
  ShowErrorViewer(SHOW_NET_ERROR_VIEWER);
  ShowPatternErrorViewer(SHOW_PATTERN_ERROR_VIEWER);
}

// Einstellungen die den "Teacher" betreffen.
void Teacher_Settings()
{
  SetTeachSpeed(0);                                      // Hier kann die Geschwindigkeit des "teaching" verringert werden z.B. 1.
  SetThinkSpeed(0);                                      // Hier kann die Geschwindigkeit des "thinking" verringert werden z.B. 1.
  SelectTeacher(TEACHER_NAME);                           // Der Name des Teachers.
  TeacherSetting(LEARNRATE, TEACHER_LEARN_RATE);         // Die Lernrate des Teachers.
  TeacherSetting(PATTERN_SELECT, TEACHER_PATTERN_ORDER); // Die Trainingsdaten werden in der Reihenfolge von "TEACHER_PATTERN_ORDER" verarbeitet.

  if (EXIT_LEARNING_BY_NET_ERROR)                        // Ist "EXIT_LEARNING_BY_NET_ERROR = true" wird der Wert entsprechend gesetzt.
  {
    TeacherSetting(TARGET_ERR, EXIT_LEARNING_NET_ERROR); // Bei erreichen eines NetErrors von "EXIT_NET_ERROR" wird das Training abgebrochen.
  }

  else                                                   // Ist "EXIT_LEARNING_BY_NET_ERROR = false" wird der "Net Error" auf (0) gesetzt.
  {
    TeacherSetting(TARGET_ERR, 0.0);                     // Bei erreichen eines NetErrors von "0" wird das Training abgebrochen.
  }
}

// Subern der "Output" Lesson.
void Clear_Output_Lesson()
{
  SelectLesson(LESSON_FOR_OUTPUT); // Die "Output" Lesson aktivieren.
  ClearLesson();                   // Die "Output" Lesson fr spteren Output subern.
}

// Aktivieren der "Normalize" Lesson zum normalisieren.
void Select_Normalize_Lesson()
{
  SelectLesson(LESSON_FOR_NORMALIZE); // Die "Normalize" Lesson zum normalisieren des Netzes aktivieren.
  EnableLessonOutData(true);          // Die Outputs der Lessons aktivieren.
}

// Das Netz normalisieren.
void Normalize_Net()
{
  Editor.NormalizeNetWithActiveLesson(); // Das Netz wird mit der aktiven "Normalize" Lesson normalisieren.
}

// Verschiedene Werte zurcksetzen / initialisieren.
// Diese Funktion wird bei jedem Durchlauf des Script's ausgefhrt.
void Init_Always()
{
  ResetThinkSteps(); // Die "ThinkSteps" werden auf "0" gesetzt.
}

// Aktivieren der "Learn" Lesson fr's Training.
void Select_Learn_Lesson()
{
  SelectLesson(LESSON_FOR_LEARN); // Die "Learn" Lesson zum trainieren des Netzes aktivieren.
  EnableLessonOutData(true);      // Die Outputs der Lessons aktivieren.
}

// Aktivieren der "Validate" Lesson zum berechnen des Net Errors.
void Select_Net_Error_Lesson()
{
  SelectNetErrLesson(LESSON_FOR_VALIDATE); // Die "Validate" Lesson zum berechnen des Net Errors aktivieren.
  EnableLessonOutData(true);               // Die Outputs der Lessons aktivieren.
  ShowLessonEditor(false);                 // Der "Lesson Editor" soll NICHT angezeigt werden.
}

// Das Netz zurcksetzen.
void Reset_Net()
{
  RandomizeNet(); // Das Netz mit Zufallswerten initialisieren.
  ResetNet();     // Das Netz resetten.
                  // (Alle Aktivitten auf NULL setzen, nur bei zeitabhngigen Netzen notwendig,
                  // strt aber bei nicht zeitabhngigen Netzen nicht, kann also immer gemacht werden).
}

// Trainieren des Netzes.
void Train_Net()
{
  teacher_Exit_Code = 0;
  uint32 exit_Learn_Seconds = 0;                           // Die Trainingszeit wird auf "0" Sekunden gesetzen.
  uint32 exit_Learn_Lesson_Repetitions = 0;                // Die Anzahl der "Learn" Lesson Durchlufe wird auf "0" gesetzen.

  SecondsTimer Learn_Time();                               // Der Timer fr die "Trainingszeit" wird gestartet.
  SecondsTimer Y_Fit(Y_FIT_PATTERN_ERROR_VIEWER);          // Der Timer fr "Pattern Error Viewer Y-Fit" wird gestartet.
  StartTeaching();                                         // Der Teacher / Lehrer wird gestartet.
  bool teacher_Running = true;                             // Der Teacher / Lehrer luft, (true = Ja).

  // Diese Schleife wird durchlaufen, bis eines der Kriterien zum Abbruch des Trainings erreicht wird.
  // 1. Die max. Trainingszeit.
  // 2. Die max. Durchlufe der Learn - Lesson.
  // 3. Der bei "EXIT_LEARNING_NET_ERROR" eingetragene Net Error.
  while (teacher_Running) // Diese Schleife wird durchlaufen, solange der Teacher / Lehrer luft.
  {
    if (EXIT_LEARNING_BY_TIME)                             // Ist "EXIT_LEARNING_BY_TIME" = true, dann hier weiter.
    {
      exit_Learn_Seconds = Learn_Time.SecondsSinceStart(); // "exit_Learn_Seconds" auf die aktuelle "Trainingszeit (Sekunden)" setzen.

      if (exit_Learn_Seconds >= EXIT_LEARNING_MAX_SECONDS) // Ist die max. Trainingszeit erreicht ?
      {
        teacher_Exit_Code = 1;                             // Das Training wurde durch "Trainingszeit" beendet.
        Trace("Das Training wurde abgebrochen...\n");      // Ausgabe im "Trace - Windows".
        Trace("Die max. Trainingszeit von: " + EXIT_LEARNING_MAX_SECONDS + " Sekunden wurde erreicht.\n\n"); // Ausgabe im "Trace - Windows".
        break;                                             // Die "While Schleife" wird verlassen, da die "max. Trainingszeit" erreicht wurde.
      }
    }

    if (EXIT_LEARNING_BY_LESSON_REPETITIONS)               // Ist "EXIT_LEARNING_BY_LESSON_REPETITIONS" = true, dann hier weiter.
    {
      exit_Learn_Lesson_Repetitions = GetLessonReps();     // "exit_Learn_Lesson_Repetitions" auf die aktuellen "Lesson Durchlufe" setzen.

      if (exit_Learn_Lesson_Repetitions >= EXIT_LEARNING_MAX_LESSON_REPETITIONS) // Sind die max. Lesson Durchlufe erreicht ?
      {
        teacher_Exit_Code = 2;                             // Das Training wurde durch "Lesson Repetitions" beendet.
        Trace("Das Training wurde abgebrochen...\n");      // Ausgabe im "Trace - Windows".
        Trace("Die Trainings - Lesson wurde: " + EXIT_LEARNING_MAX_LESSON_REPETITIONS + " mal durchlaufen.\n\n"); // Ausgabe im "Trace - Windows".
        break;                                             // Die "While Schleife" wird verlassen, da die "max. Lesson Repetitions" erreicht wurden.
      }
    }

    teacher_Running = !SleepExec(100);                     // Fr max. 100ms auf das Beenden des Trainings warten.

    if (Y_Fit.IsElapsed())                                 // Ist der Timer "Y_Fit" abgelaufen, dann hier weiter.
    {
      PatternErrorViewerFitYScale();                       // Beim "Patern Error Viewer" Fit Y-Scale ausfhren.
      Y_Fit.Start(Y_FIT_PATTERN_ERROR_VIEWER);             // Den Timer "Y_Fit" zurcksetzen auf "Y_FIT_PATTERN_ERROR_VIEWER".
    }
  }
    
  ETeachResult teachResult = GetLastTeachResult();         // Auf welche Art wurde der Teacher / Lehrer beendet.

  if (teacher_Running)                                     // Wenn der Teacher / Lehrer noch luft, dann hier weiter.
  {
    StopTeaching();                                        // Das Training wird gestoppt (wenn noch nicht der Fall), da eines der Abbruch - Kriterien erreicht wurde.
  }
        
  if (teachResult == TR_TARGET_NET_ERROR_REACHED)          // Wenn der "Net Error" erreicht wurde, dann hier weiter.
  {
    teacher_Exit_Code = 3;                                 // Das Training wurde durch "Net Error" beendet.
    Trace("Das Training wurde abgebrochen...\n");          // Ausgabe im "Trace - Windows".
    Trace("Der Net Error von: " + GetNetError() + " wurde erreicht.\n\n"); // Ausgabe im "Trace - Windows".
  }
}

// Speichern der Netzdatei z.B. "Net.mbn".
void Save_Net()
{
  SaveNet(NET_FILE_NAME); // Das Netz speichern.
}

// Aktivieren der "Think" Lesson zum erzeugen des Outputs.
void Select_Think_Lesson()
{
  SelectLesson(LESSON_FOR_THINK); // Die "Think" Lesson zum (denken) mit dem Netz aktivieren.
  EnableLessonOutData(false);     // Die Outputs der Lesson DEaktivieren, diese Lesson hat keine Outputs.
}

// Abarbeiten der "Think" Lesson.
void Think_Lesson()
{
  // NUR wenn der Teacher durch "Zeit" abgebrochen wurde, UND "THINK_OUTPUT_BY_TIME" auf "true" steht,
  // wird die "Tink" Lesson abgearbeitet und ein "Output" erzeugt / gespeichert.
  if ((teacher_Exit_Code == 1) && (THINK_OUTPUT_BY_TIME == true))
  {
    SetRecordingType(RT_ACT);          // Setze Output auf Aktivation.
    StartRecording(LESSON_FOR_OUTPUT); // Starte Aufzeichnung auf die "Output" Lesson.
    ThinkLesson();                     // Das Netz macht jetzt einen "Denkschritt" pro Zeile in der "Thinking" Lesson, der Output geht nach "Output.csv".
    SleepExec();                       // Abwarten bis die "Thinking" Lesson abgearbeitet ist.
    StopRecording();                   // Aufzeichnung auf Lesson "5" beenden.
  }

  // NUR wenn der Teacher durch "Lesson Repetitions" abgebrochen wurde, UND "THINK_OUTPUT_BY_LESSON_REPETITIONS" auf "true" steht,
  // wird die "Tink" Lesson abgearbeitet und ein "Output" erzeugt / gespeichert.
  if ((teacher_Exit_Code == 2) && (THINK_OUTPUT_BY_LESSON_REPETITIONS == true))
  {
    SetRecordingType(RT_ACT);          // Setze Output auf Aktivation.
    StartRecording(LESSON_FOR_OUTPUT); // Starte Aufzeichnung auf die "Output" Lesson.
    ThinkLesson();                     // Das Netz macht jetzt einen "Denkschritt" pro Zeile in der "Thinking" Lesson, der Output geht nach "Output.csv".
    SleepExec();                       // Abwarten bis die "Thinking" Lesson abgearbeitet ist.
    StopRecording();                   // Aufzeichnung auf Lesson "5" beenden.
  }

  // NUR wenn der Teacher durch "Net Error" abgebrochen wurde, UND "THINK_OUTPUT_BY_NET_ERROR" auf "true" steht,
  // wird die "Tink" Lesson abgearbeitet und ein "Output" erzeugt / gespeichert.
  if ((teacher_Exit_Code == 3) && (THINK_OUTPUT_BY_NET_ERROR == true))
  {
    SetRecordingType(RT_ACT);          // Setze Output auf Aktivation.
    StartRecording(LESSON_FOR_OUTPUT); // Starte Aufzeichnung auf die "Output" Lesson.
    ThinkLesson();                     // Das Netz macht jetzt einen "Denkschritt" pro Zeile in der "Thinking" Lesson, der Output geht nach "Output.csv".
    SleepExec();                       // Abwarten bis die "Thinking" Lesson abgearbeitet ist.
    StopRecording();                   // Aufzeichnung auf Lesson "5" beenden.
  }
}

// Aktivieren der "Output" Lesson zum abspeichern des Outputs.
void Select_Output_Lesson()
{
  SelectLesson(LESSON_FOR_OUTPUT); // Die "Output" Lesson zum abspeichern des Outputs aktivieren.
  EnableLessonOutData(true);       // Die Outputs der Lesson aktivieren.
}

// Abspeichern des Output's in (Output.csv).
void Save_Output()
{

  if (INCLUDE_INPUT_DATA_IN_OUTPUT_LESSON)           // Ist "INCLUDE_INPUT_DATA_IN_OUTPUT_LESSON" = true, dann hier weiter.
  {
    ExportLessonRaw(OUTPUT_LESSON_FILE_NAME);        // Die (IN/OUT puts) der "Output" Lesson in der Datei "OUTPUT_LESSON_FILE_NAME" abspeichern.
  }
  
  else                                               // Ist "INCLUDE_INPUT_DATA_IN_OUTPUT_LESSON" = false, dann hier weiter.
  {
    ExportLessonOutputsRaw(OUTPUT_LESSON_FILE_NAME); // NUR die (OUT puts) der "Output" Lesson in der Datei "OUTPUT_LESSON_FILE_NAME" abspeichern.
  }
}

// ffnen der "Output" CSV-Datei z.B. mit Excel.
void Open_Output_File()
{

  if (OPEN_OUTPUT_FILE_ON_EXIT)                                 // Ist "OPEN_OUTPUT_FILE_ON_EXIT" = true, dann hier weiter.
  {

    if (!ShellExecute("open", OUTPUT_LESSON_FILE_NAME, ""))     // Wenn mglich, die "Output.csv" ffnen.
    {
      Error("Die Output - Datei kann nicht geffnet werden !"); // Wenn nicht mglich, wird eine Fehlermeldung angezeigt.
    }
  }
}

// Aufrumen bevor das Script beendet wird.
void Clear_Before_Exit()
{
  ShowLessonEditor(false);       // Der "Lesson Editor" soll wieder ausgeblendet werden.
  ShowErrorViewer(false);        // Der "Net Error Viewer" soll wieder ausgeblendet werden.
  ShowPatternErrorViewer(false); // Der "Pattern Error Viewer" soll wieder ausgeblendet werden.
}

// Fehlerbehandlung.
void Error(string errorText)
{
    Trace(errorText + "\n"); // Ausgeben der Fehlermeldung im "Trace - Windows".
    AbortScript();           // Das Script wegen Fehler abbrechen...
}
